/* Plugin generated by AMXX-Studio */

#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>
#include <engine>
#include <cstrike>

#define PLUGIN "[Z]Weapon:Galil Maverick"
#define VERSION "1.0"
#define AUTHOR "batcon"

#define m_rgpPlayerItems_CWeaponBox  34
#define m_pPlayer                    41
#define m_pNext                      42
#define m_fInReload                  54
#define m_flNextAttack               83
#define m_rpgPlayerItems             367

#define CustomItem(%0) (pev(%0, pev_impulse) == g_WeaponKey)
#define WEAPON_MODEL_V "models/v_galilcraft.mdl"
#define WEAPON_MODEL_P "models/p_galilcraft.mdl"
#define WEAPON_MODEL_W "models/w_galilcraft.mdl"
#define WEAPON_NAME    "weapon_galilcraft"
#define WEAPON_CLIP 45
#define WEAPON_AMMO 90
	
static g_WeaponKey, g_msg_Weaponlist	
	
public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR);
	RegisterHam(Ham_Item_Deploy, "weapon_galil", "fw_Item_Deploy_Post", 1);
	RegisterHam(Ham_Weapon_Reload, "weapon_galil", "fw_Weapon_Reload");
	RegisterHam(Ham_Item_PostFrame, "weapon_galil", "fw_Item_PostFrame");
	RegisterHam(Ham_Item_AddToPlayer, "weapon_galil", "fw_Item_AddToPlayer_Post", 1);
	RegisterHam(Ham_Spawn, "weaponbox", "fw_Spawn_Weaponbox_Post", 1);
	register_forward(FM_SetModel, "fw_SetModel");
	state WeaponBox_Disabled;
	g_msg_Weaponlist = get_user_msgid("WeaponList");
	register_clcmd(WEAPON_NAME, "Hook_Weapon");	
}
public plugin_precache() {
	engfunc(EngFunc_PrecacheModel, WEAPON_MODEL_V);
	engfunc(EngFunc_PrecacheModel, WEAPON_MODEL_P);
	engfunc(EngFunc_PrecacheModel, WEAPON_MODEL_W);
	engfunc(EngFunc_PrecacheSound, "weapons/galilcraft_clipout.wav");
	engfunc(EngFunc_PrecacheSound, "weapons/galilcraft_clipin.wav");
	engfunc(EngFunc_PrecacheSound, "weapons/galilcraft_boltpull.wav");
	engfunc(EngFunc_PrecacheGeneric, "sprites/weapon_galilcraft.txt");
	engfunc(EngFunc_PrecacheGeneric, "sprites/640hud107.spr");
	g_WeaponKey = engfunc(EngFunc_AllocString, WEAPON_NAME);
}
public Hook_Weapon(id) engclient_cmd(id, "weapon_galil");
public plugin_natives() register_native("give_weapon_galilcraft", "give_galilcraft", 1);
public give_galilcraft(id) {
	UTIL_DropWeapon(id, 1);
	give_weapon(id);
	emit_sound(id, CHAN_ITEM, "items/gunpickup2.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM);
	ExecuteHamB(Ham_GiveAmmo, id, WEAPON_AMMO, "556nato", WEAPON_AMMO);
}
public give_weapon(id) {
	new ent = create_entity("weapon_galil");
	if(!is_valid_ent(ent)) return 0;
	set_pev(ent, pev_spawnflags, SF_NORESPAWN);
	set_pev(ent, pev_impulse, g_WeaponKey);
	ExecuteHam(Ham_Spawn, ent);
	if(!ExecuteHamB(Ham_AddPlayerItem, id, ent)) {
		remove_entity(ent);
		return 0;
	}
	cs_set_weapon_ammo(ent, WEAPON_CLIP);
	ExecuteHamB(Ham_Item_AttachToPlayer, ent, id);
	return 1;
}
public fw_Item_Deploy_Post(ent) {
	if(!CustomItem(ent)) return HAM_IGNORED;
	static id; id = get_pdata_cbase(ent, m_pPlayer, 4);
	set_pev(id, pev_viewmodel2, WEAPON_MODEL_V);
	set_pev(id, pev_weaponmodel2, WEAPON_MODEL_P);
	UTIL_PlayWeaponAnimation(id, 2);
	set_pdata_float(id, m_flNextAttack, 1.2, 5);
	return HAM_IGNORED;
}
public fw_Weapon_Reload(ent) {
	if(!CustomItem(ent)) return HAM_IGNORED;
	static id; id = get_pdata_cbase(ent, m_pPlayer, 4);
	static clip; clip = cs_get_weapon_ammo(ent);
	if(cs_get_user_bpammo(id, CSW_GALIL) <= 0 || clip >= WEAPON_CLIP) return HAM_SUPERCEDE;
	cs_set_weapon_ammo(ent, 0);
	ExecuteHam(Ham_Weapon_Reload, ent);
	cs_set_weapon_ammo(ent, clip);
	UTIL_PlayWeaponAnimation(id, 1);
	set_pdata_float(id, m_flNextAttack, 2.3, 5);
	set_pdata_int(ent, m_fInReload, 1, 4);
	return HAM_SUPERCEDE;
}
public fw_Item_PostFrame(ent) {
	if(!CustomItem(ent)) return HAM_IGNORED;
	if(get_pdata_int(ent, m_fInReload, 4)) {
		static clip; clip = cs_get_weapon_ammo(ent);
		static id; id = get_pdata_cbase(ent, m_pPlayer, 4);
		static ammo; ammo = cs_get_user_bpammo(id, CSW_GALIL);
		static j; j = min(WEAPON_CLIP - clip, ammo); 
		cs_set_weapon_ammo(ent, clip+j);
		cs_set_user_bpammo(id, CSW_GALIL, ammo-j);
		set_pdata_int(ent, m_fInReload, 0, 4);
	}
	return HAM_IGNORED;
}
public fw_Item_AddToPlayer_Post(ent, id) {
	static key; key = pev(ent, pev_impulse);
	if(!key || key == g_WeaponKey) {
		message_begin(MSG_ONE, g_msg_Weaponlist, _, id);
		write_string(key ? WEAPON_NAME : "weapon_galil"); 
	        write_byte(4);
	        write_byte(key ? WEAPON_AMMO : 90);
	        write_byte(-1);
	        write_byte(-1);
	        write_byte(0);
	        write_byte(17);
	        write_byte(CSW_GALIL);
	        write_byte(0);
	        message_end();
	}
}	
public fw_Spawn_Weaponbox_Post(ent) {
	if(is_valid_ent(ent))
		state (is_valid_ent(pev(ent, pev_owner))) WeaponBox_Enabled;
}	
public fw_SetModel(entity) <WeaponBox_Enabled>
{
	state WeaponBox_Disabled;
	if(!is_valid_ent(entity)) return FMRES_IGNORED;
		
	for(new i, item; i < 6; i++) {
		item = get_pdata_cbase(entity, m_rgpPlayerItems_CWeaponBox + i, 4);
		if(is_valid_ent(item) && CustomItem(item)) {
			entity_set_model(entity, WEAPON_MODEL_W);
			return FMRES_SUPERCEDE;
		}
	}
	return FMRES_IGNORED;
}
public fw_SetModel() <WeaponBox_Disabled>
{
	return FMRES_IGNORED;
}
stock UTIL_PlayWeaponAnimation(id, Sequence) {
         set_pev(id, pev_weaponanim, Sequence);
	 message_begin(MSG_ONE_UNRELIABLE, SVC_WEAPONANIM, _, id);
         write_byte(Sequence);
         write_byte(0);
         message_end();
}
stock UTIL_DropWeapon(id, slot) {
         if(!(1 <= slot <= 2)) return 0;
         new iCount; 
         new iEntity = get_pdata_cbase(id, (m_rpgPlayerItems + slot), 5);
         if(iEntity > 0) {
                new iNext;
                static szWeaponName[32];
       
                do{
                        iNext = get_pdata_cbase(iEntity, m_pNext, 4);
                        if(get_weaponname(cs_get_weapon_id(iEntity), szWeaponName, charsmax(szWeaponName))) {  
                                engclient_cmd(id, "drop", szWeaponName);
                                iCount++;
			}
                } while(( iEntity = iNext) > 0);
	}
         return iCount;
}
   
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1049\\ f0\\ fs16 \n\\ par }
*/
